Livrable/Gestionnaire_de_Projets/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();

Route::get('notif', function(){
});
Route::get('/user/notif/seen/{data}','HomeController@notifSeen')->name('user.notif.seen');
Route::get('/admin/register', 'HomeController@adminRegisterIndex')->name('admin.register.index');//->middleware('admin')
Route::post('/admin/register/save', 'HomeController@firstAdminStore')->name('admin.register.save');

Route::get('/register', 'UserController@registerIndex')->name('register.index');/*->middleware('can:create,App\User');*/
Route::get('/register/save', 'UserController@store')->name('register.save');

Route::get('/', 'HomeController@index')->name('home.index');

Route::resource('Projects','ProjectController');
Route::resource('Tasks','TaskController');

Route::get('/{id}/myProjects','ProjectController@ManagerProjets')->name('Project.ManagerProjets');

Route::match(['PUT', 'PATCH'],'/Tasks/{id}/save','TaskController@updateProgress')->name('Tasks.updateProgress');
//Route::match(['PUT', 'PATCH'], '/Tasks/{id}/add/{empid}',)->name('Tasks.addEmployee');
Route::get('Tasks/delete/{id}/{empid}','TaskController@deleteEmployee')->name('Tasks.deleteEmployee');
Route::get('Tasks/add/{id}/{empid}','TaskController@addEmployee')->name('Tasks.addEmployee');

Route::get('/{id}/myTasks','TaskController@MyTasks')->name('Tasks.MyTasks');
Route::get('/addTask/{id_proj}','TaskController@addTaskToPrj')->name('Tasks.addTaskToPrj');/* ~~ */

Route::resource('Clients','ClientController');
Route::resource('Users','UserController');
Route::get('User/editPassword','UserController@editPassword')->name('User.editPassword');
Route::match(['PUT', 'PATCH'],'User/updatePassword','UserController@updatePassword')->name('User.updatePassword');


Route::get('/Userprofile/{id}','UserController@showProfile')->name('User.Profile');
Route::post('/profile/{userID}','UserController@update_avatar')->name('User.updateAvatar');

Route::get('datatables/{name}', 'HomeController@index2')->name('datatables');
Route::get('datatables/getdata/{name}', 'HomeController@getData')->name('datatables.getdata');

// Route::get('ajaxdata/removedata/{name}', 'HomeController@removedata')->name('datatables.removedata');
Route::get('ajaxdata/massremove/{name}', 'HomeController@massremove')->name('datatables.massremove');
Route::get('calendar','CalendarController@index')->name('calendar.index');
Route::post('calendar','CalendarController@addProject')->name('calendar.addProject');
?>

Livrable/Gestionnaire_de_Projets/app/Project.php
<?php

namespace App;
use Carbon\Carbon;
use App\Task;
use App\Task_User;

use Illuminate\Database\Eloquent\Model;

class Project extends Model
{
	protected $fillable = [
			 'title','description','limitDate','startDate','finishDate','displacement',
			 'state','comment','user_id','client_id'
				 ];
		public $timestamps = true;

	public function tasks(){
		return $this->hasMany('App\Task');
	}

	public function clients(){
		return $this->belongsTo('App\Client');
	}
	/*
	* Une fois le projet cloturé, une date de fin doit être définie
	*/
	public function projetClos()
	{
		if($this->state == 0 && $this->finishDate == null){/*si le projet est clos*/
			return true;
			 /*  $project->finishDate=date('Y-m-d H:i:s');on precise la date de fin*/
		}else{
			return false;
			// $project->finishDate='0000-00-00 00:00:00';
		}
	}

	public static function getCounts($v){//$v est le diff par minutes
		$temp = $v/60/24;
		$vv = " ".floor($temp).'day(s)';
		$temp = ($temp -floor($temp)) *24;
		$vv = $vv." ".floor($temp).'hour(s)';
		$temp = ($temp -floor($temp)) *60;
		$vv = $vv." ".$temp.'min(s)';
		return $vv;
	}

	public static function useData_toCalculateHoursCount($t_us){
		$i=0;
		$t = [];
		$resM = 0;
		foreach ($t_us as $t_u) {
			$from = Carbon::parse($t_u->startDate);
			$to = Carbon::parse($t_u->finishDate);

			$currentCount = 0;

			if($t_u->needCalculating){
				$currentCount = $to->diffInMinutes($from) + $t_u->hoursCount*60;
			}else{
				$currentCount = $t_u->hoursCount*60;
			}

			$resM += $currentCount;
			$t[$i] = '('.$t_u->task_id.') '.$t_u->startDate.'. '.
				($t_u->finishDate?$t_u->finishDate
					.' '.Project::getCounts($to->diffInMinutes($from))
					.' '.Project::getCounts($currentCount)
					:'null').' :'.$t_u->hoursCount.':';

			$i++;
		}

		$fullRes = ' '.Project::getCounts($resM);

		return ($resM/60).'hour(s) = '.$resM.'minute(s) = '.$fullRes;
		// $dt = Carbon::parse('2012-10-5 23:26:11.123789');//$dt->day == Carbon::now()->day
	}
}

Livrable/Gestionnaire_de_Projets/resources/views/projects/create.blade.php
@extends('layouts.structure')

@section('csss')
	@parent
	<link href="{{ asset('css/bootstrap-datetimepicker.min.css') }}" rel="stylesheet">
	<link href="{{ asset('fonts/fontawesome/css/all.css') }}" rel="stylesheet">
@endsection

@section('content')


 <div class="page-header">
		<div class="form-group align-center">
			     	<h2 style="color :green" >Nouveau Projet </h2>
	  </div>
</div>
<br><br>
<form role="form" method="post" action="{{action('ProjectController@store')}}">
<input type="hidden" name="_token" value="{!! csrf_token() !!}">

	<div class="form-group">
		<label for="title" class="col-form-label">Sujet :</label>
		<input  type="text" class="form-control" name="title" required>
	</div>

	<div class="form-row">
		<div class="form-group col">
			<label class="col-form-label col-md-2 col-sm-12">État :</label>
			<div class="form-check form-check-inline">
				<input class="form-check-input" type="radio" name="state_RadioBtn" id="EnCours_RadioBtn" value="1" checked >
				<label class="form-check-label" for="EnCours_RadioBtn">En-cours</label>
			</div>
			<div class="form-check form-check-inline">
				<input class="form-check-input" type="radio" name="state_RadioBtn" id="Clos_RadioBtn" value="0">
				<label class="form-check-label" for="Clos_RadioBtn">Clos</label>
			</div>
		</div>

		<div class="form-group col">
			<label for="limitDate" class="col-form-label">Date Limite :</label>
			<div class="input-group date form_datetime col-md-5"
				data-date="1979-09-16T05:25:07Z" data-date-format="yyyy-mm-dd hh:ii:ss"
				data-link-field="dtp_input1"
				style="min-width: 300px;">

				<input id="limitDate" name="limitDate" class="form-control" size="16" type="text" value="2019-09-09 11:36:04" readonly>
				<span class="input-group-append">
					<span class="input-group-text fa fa-times fa-lg"></span>
				</span>
				<span class="input-group-append">
					<span class="input-group-text fa fa-calendar-alt fa-lg"></span>
				</span>
			</div>
			<input type="hidden" id="dtp_input1" value=""/><br/>
		</div>

	</div>
	<div class="form-group col-lg-12">
		<div class="form-check">
			<input class="form-check-input" type="checkbox" id="displacement" name="displacement" checked>
			<label class="form-check-label" for="displacement">
				Déplacement
			</label>
		</div>
	</div>
	<div class="form-row">
		<div class="form-group col">
			<label class="col-form-label">Client :</label>
			<select name = "client_id[]" id="client_id" class="form-control">
				@foreach ($clients as $client)
					<option value="{{ $client['id'] }}">{{ $client['name'] }}</option>
				@endforeach
			</select>
		</div>

		<div class="form-group col">
			<label class="col-form-label">Chef de Projet :</label>
			<select name = "user_id[]" id="user_id" class="form-control">
				@foreach ($project_managers as $project_manager)
					<option value="{{ $project_manager['id'] }}">{{ $project_manager['name'] }}</option>
				@endforeach
			</select>
		</div>
	</div>

	<div class="form-group">
		<label for="description" class="col-form-label">Description :</label>
		<textarea class="form-control" rows="6" name="description" id="description" required></textarea>
	</div>

	<div class="form-group">
		<label class="col-form-label">Commentaire :</label>
		<textarea class="form-control" rows="6" name="comment" id="comment" required></textarea>
	</div>

<input type="submit" class="btn btn-success btn-h1-spacing float-right" value="Ajouter">
</form>

@endsection


@section('jss')
	@parent
	<script src="{{ asset('js/bootstrap-datetimepicker.js') }}" type="text/javascript"></script>
	<script src="{{ asset('js/bootstrap-datetimepicker.fr.js') }}" type="text/javascript"></script>
	<script src="{{ asset('js/bootstrap-datetimepicker-setup.js') }}"  type="text/javascript"></script>
@endsection

Livrable/Gestionnaire_de_Projets/resources/views/projects/edit.blade.php
@extends('layouts.structure')
@section('csss')
	@parent
	<link href="{{ asset('css/bootstrap-datetimepicker.min.css') }}" rel="stylesheet">
	<link href="{{ asset('fonts/fontawesome/css/all.css') }}" rel="stylesheet">
@endsection

@section('content')

	<div class="page-header">
		<div class="form-group form-inline align-center">
			<h2 style="color :green" > Modifier le Projet : </h2>
			<h3 style="color :gray" class="ml-5">{{ $p->title }}</h3>
		</div>
	</div>
	<hr>

<form action="{{ route('Projects.update', $p) }}" method="POST" class="form-horizontal">
<input type="hidden" name="_method" value="PUT">
<input type="hidden" name="_token" value="{{ csrf_token() }}">

	<div class="form-group">
		<label for="title" class="col-form-label" >Sujet :</label>
		<input type="text" class="form-control " name="title" value="{{$p->title}}">
	</div>
	<div class="form-row">
		<div class="form-group col">
			<label class="col-form-label mt-0">Client :</label>
			<div class="form-control" name="client_id"> {{$p->client_name}}</div>
		</div>
		<div class="form-group col">
			<label class="form-label mt-1" >Chef de Projet :</label>
			<select name = "user_id[]" id="user_id" class="form-control">
				@foreach ($project_managers as $project_manager)
					<option value="{{ $project_manager['id'] }}">{{ $project_manager['name'] }}</option>
				@endforeach
			</select>
		</div>
	</div>
	<div class="form-row">
		<div class="form-group col">
			<label for="limitDate" class="col-form-label">Date Limite :</label>
			<div class="input-group date form_datetime"
                data-date="1979-09-16T05:25:07Z" data-date-format="yyyy-mm-dd hh:ii:ss"
				data-link-field="dtp_input1"
				style="min-width: 350px;">
				<input id="limitDate" name="limitDate" class="form-control" size="16" type="text" value="{{ $p->limitDate }}" readonly>
				<span class="input-group-append">
					<span class="input-group-text fa fa-times fa-lg"></span>
				</span>
				<span class="input-group-append">
					<span class="input-group-text fa fa-calendar-alt fa-lg"></span>
				</span>
			</div>
			<input type="hidden" id="dtp_input1" value=""/><br/>
		</div>
		<div class="col form-row">
			<!--état-->
			<div class="form-group col ml-5">
				<label class="col-form-label ">Etat :</label><br>
				<div class="form-check form-check-inline">
					<input class="form-check-input" type="radio" name="state_RadioBtn"
						id="EnCours_RadioBtn" value="1" <?php echo ($p->state)?'checked':''?>
						{{(Auth::user()->Auth_hasRole('ADMIN')||Auth::user()->Auth_hasRole('MANAGER'))?'':'disabled'}}
						>
					<label  class="form-check-label" for="EnCours_RadioBtn">en-cours</label>

					<input class="form-check-input ml-3" type="radio" name="state_RadioBtn"
						id="Clos_RadioBtn" value="0" <?php echo (!$p->state)?'checked':'' ?>
						{{(Auth::user()->Auth_hasRole('ADMIN')||Auth::user()->Auth_hasRole('MANAGER'))?'':'disabled'}}>
					<label class="form-check-label" for="Clos_RadioBtn">clos</label>
				</div>
			</div>
			<!--déplacement-->
			<div class="form-group col mt-4">
				<div class="form-check">
					<input class="form-check-input" type="checkbox" name="displacement"
						id="displacement" <?php echo ($p->displacement)?'checked':'' ?> >
					<label class="form-check-label" for="displacement">
						Déplacement
					</label>
				</div>
			</div>
		</div>
	</div>

    <div class="form-group">
         <label for="description" class="col-form-label" >Description :</label>
         <textarea class="form-control" rows="4" name="description" value="description">{{$p->description}}</textarea>
    </div>

  <div class="form-groupe">
    <label class="col-form-label" >Commentaire :</label></strong>
    <textarea class="form-control" rows="4" name="comment" value="" >{{$p->comment}}</textarea>
  </div>
<br>
 <button type="submit" name="submit" class="btn btn-primary float-right"> <i class="fas fa-save"> Enregistrer</i></button>

    </form>
<hr>
<br>


@endsection

@section('jss')
	@parent
   <script src="{{ asset('js/bootstrap-datetimepicker.js') }}" type="text/javascript"></script>
	<script src="{{ asset('js/bootstrap-datetimepicker.fr.js') }}" type="text/javascript"></script>
	<script src="{{ asset('js/bootstrap-datetimepicker-setup.js') }}"  type="text/javascript"></script>
     @endsection

Livrable/Gestionnaire_de_Projets/resources/views/projects/index.blade.php
@extends('layouts.structure')


@section('content')

<style> h2{ color: green; } </style>
 <div class="page-header">
		<div class="form-group align-center">
      <?php if(isset($func)):?>
        <h2>Mes Projets</h2>
      <?php else: ?>
			<h2>Liste des Projets</h2>
    <?php endif; ?>
    </div>
</div>
<br><br>
<table class="table table-responsive-lg mr-2">
<thead class="thead-dark" >
	<tr>
		<th scope="col">Titre</th>
		<th scope="col">Client</th>
		{{-- <th scope="col">Date debut</th> --}}
    <th scope="col">Date limite</th>
		{{-- <th scope="col">Date fin</th> --}}
			<?php if(isset($func)):?>
			<th scope="col">Déplacement</th>
			<?php else: ?>
			<th scope="col">Chef de Projet</th>
		<?php endif; ?>
		<th scope="col">Etat</th>
		<th scope="col"></th>
		<th scope="col"></th>
		<th scope="col"></th>
	</tr>
</thead>
<tbody>
	@foreach($ps as $p)
    @if($p->state=='clos')
  	<tr class="table-success">
    @else
    <tr>
    @endif

  		<td scope="row">{{$p->title}}</th>
  		<td>{{$p->client_name}}</td>
  		{{-- <td>{{date('Y-m-d', strtotime($p->startDate))}}</td> --}}
      <td>  <div style="color:green;font-weight:bold">{{date('Y-m-d', strtotime($p->limitDate))}}</div></td>

      {{-- <td>{{ ($p->finishDate) ? date("Y-m-d", strtotime($p->finishDate)) : "inachevé"}}</td> --}}


      {{-- <td> <div style="color: blue;font-weight:bold">{{ ($p->finishDate) ? date("M j Y - H:i", strtotime($p->finishDate)) : ""}} </div></td> --}}

			<?php if(isset($func)):?>
	   	<td>{{($p->displacement)?'Oui':'No'}}</td>
		  <?php else: ?>
			<td>{{$p->chef}}</td>
		  <?php endif; ?>
  		<td>{{($p->state)?'en-cours':'clos'}}</td>
  		<td>
  		<td>
        <td scope="row">
          <form action="{{ route('Projects.show',$p->id) }}" id="show{{$p->id}}" method="get"></form>
          <form action="{{ route('Projects.edit',$p->id) }}" id="edit{{$p->id}}" method="get"></form>
          <form action="{{ route('Projects.destroy',$p->id) }}" id="delete{{$p->id}}" method="post">
            {!! method_field('delete') !!}{!! csrf_field() !!}
          </form>
          <div class="btn-group" role="group" aria-label="Basic example">
            <i class="btn btn-success fa fa-eye text-dark" aria-hidden="true"
              onclick="$('#show{{$p->id}}').submit();" value="v"></i>
						@if(!Auth::user()->Auth_hasRole('EMPLOYEE'))
              @if($p->state!=0)<!--ompossible d'éditer un projet clos -->
            <i class="btn btn-primary fas fa-pencil-alt text-dark" aria-hidden="true"
              onclick="$('#edit{{$p->id}}').submit();" value="m"></i>
            <!--<i class="btn btn-danger fas fa-times text-dark" onclick="$('#delete{{$p->id}}').submit();" value="s"></i>-->
              @endif
            @endif
          </div>
        </td>
        {{--
          can('edit',Auth::user())
  				<input type="submit" class="btn btn-primary" onclick="$('#edit{{$p->id}}').click();" value="m">
          endcan
          can('delete',Auth::user())
        	<input type="submit" class="btn btn-danger" onclick="$('#delete{{$p->id}}').click();" value="s">
          endcan--}}
  	</tr>
	@endforeach
</tbody>
</table>

@if(!$ps)
  <div class="alert alert-secondary fade show align-center form-inline" role="alert">
     Aucun Projet
  </div>
@endif

@endsection